/*
 * drivers/dec/char/lk201.c
 *
 * Copyright (C) 1997 Michael Engel
 *
 * Originally written by Michael Engel.
 *
 * The LK201 keycode mapping routine is here, along with initialization
 * functions for the keyboard and mouse.
 */
#include <asm/addrspace.h>
#include <asm/dec/kn01.h>
#include <asm/dec/prom.h>
#include "dc.h"
#include "lk201.h"

/**** FIXME: These serial interface (DEC dz chip) handling routines
 **** also belong in the drivers directory - again, leave them here for
 **** now!
 ****/

volatile struct dc_reg *sc_regs;

void pmax_cons_getch(void)
{
	int i;

	sc_regs=(struct dc_reg *)KN01_DZ11_BASE;

	/* Init serial chip */
	dc_disable_rx(DC_KB);
	dc_disable_tx(DC_KB);	
	dc_set_attributes(DC_KB, BITS8 | DC_B4800);
	dc_enable_rx(DC_KB);
/*	dc_enable_tx(DC_KB);	*/

	dc_disable_tx(DC_MS);
	
	dc_disable_rx(DC_PRINTER);
	dc_disable_tx(DC_PRINTER);	
	dc_set_attributes(DC_PRINTER, BITS8 | DC_B9600);
	dc_enable_rx(DC_PRINTER);
	dc_enable_tx(DC_PRINTER);	
	
	dc_disable_rx(DC_MODEM);
	dc_disable_tx(DC_MODEM);	
/*	dc_set_attributes(DC_MODEM, BITS8 | DC_B9600); */
/*	dc_enable_rx(DC_MODEM); */
/*	dc_enable_tx(DC_MODEM);	*/
	
	/* wait for characters */
	prom_printf("Waiting for characters from the keyboard ...\n");

	while (1)
	{
		i=(sc_regs->DZ_RBUF_LPR.DZ_RBUF);

		if ((i & 0x8000) == 0)
			continue;

		outchar(i);
	}
}

void outchar(i)
{
	static int shifted;
	static int caps;

	if (( i & 0x0300 ) != 0)
	{
		dec_cons_putc(i & 0xff);

		if ((sc_regs->DZ_CSR & 0x0300) != 0x0300)
			return;

		sc_regs->DZ_MSR_TDR.DZ_TDR=(i & 0xff);
		return;
	}

	/* sonst Console mappen ... */
	i=i&0xff;

	if ( unshiftedAscii[i] == KBD_SHIFT )
	{
		shifted=1;	
		return;
	}

	if ( unshiftedAscii[i] == KBD_NOSHIFT )
	{
		shifted=0;
		return;
	}

	if ( unshiftedAscii[i] == KBD_CAPSLOCK )
	{
		if (caps == 0)
		{
			caps=1;
			shifted=1;
		}
		else
		{
			caps=0;
			shifted=0;
		}
		return;
	}

	if (shifted)
		dec_cons_putc(shiftedAscii[i]);
	else
		dec_cons_putc(unshiftedAscii[i]);
}
