/*  
 * Miscellaneous definitions used to initialise the interrupt vector table
 * with the machine-specific interrupt routines.
 *
 * Copyright (C) 1997 by Paul M. Antoine.
 */

#ifndef __ASM_DEC_INTERRUPTS_H 
#define __ASM_DEC_INTERRUPTS_H 

#ifndef __LANGUAGE_ASSEMBLY__

/*
 * Interrupt table structure to hide differences between different
 * systems such.
 */
extern void *vector_table[8];

/*
 * PMAX interrupt routine prototypes for DS2100/3100's and possibly 5100's
 */
extern void	kn01_sii(void);
extern void	kn01_lance(void);
extern void	kn01_memctrlr(void);
extern void	kn01_dz(void);
extern void	kn01_halt(void);

/*
 * 3MAX interrupt routine prototypes for DS5000/2xx's
 */
extern void	kn02_memctrlr(void);
extern void	kn02_tc(void);

/*
 * 3MIN interrupt routine prototypes for DS5000/1xx's
 */
extern void	kn02ba_tc3(void);
extern void	kn02ba_tc2(void);
extern void	kn02ba_tc1(void);
extern void	kn02ba_tc0(void);
extern void	kn02ba_halt(void);


/*
 * MAXINE interrupt routine prototypes for DS5000/2x's
 */
extern void	kn02ca_periodic(void);
extern void	kn02ca_tc(void);
extern void	kn02ca_halt(void);

/*
 * Common interrupt routine prototypes for all DECStations
 */
extern void	dec_intr_unimplemented(void);
extern void	dec_intr_sw0(void);
extern void	dec_intr_sw1(void);
extern void	dec_intr_fpu(void);
extern void	dec_intr_rtc(void);

#endif	 __LANGUAGE_ASSEMBLY__
#endif /* __ASM_DEC_PROM_H */

