/*
 * Hardware info about DEC DECstation 5000/2xx systems (otherwise known
 * as 3max or kn02.
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 * Copyright (C) 1995,1996 by Paul M. Antoine, some code and definitions
 * are by curteousy of Chris Fraser.
 *
 * This file is under construction - you were warned!
 */
#include <asm/segment.h>
#ifndef __ASM_MIPS_DEC_KN02_H 
#define __ASM_MIPS_DEC_KN02_H 

/*
 * The addresses below are virtual address. The mappings are
 * created on startup via wired entries in the tlb.
 */

#define KN02_LOCAL_IO_SPACE     0xe0000000

/*
 * Motherboard regs (kseg1 addresses)
 */
#define KN02_CSR_ADDR	KSEG1ADDR(0x1ff00000)	/* system control & status reg */

/*
 * CSR defines
 */
#define KN02_CSR_LEDMASK	0x00000000ff		/* diagnostic LEDs */

#ifndef __LANGUAGE_ASSEMBLY__

extern __inline__ void kn02_set_led(unsigned int bits)
{
	volatile unsigned int *led_register = (unsigned int *) KN02_CSR_ADDR;

	*led_register = bits & KN02_CSR_LEDMASK;
}

#endif

/*
 * Some port addresses...
 * FIXME: these addresses are incomplete and need tidying up!
 */
#define KN02_RTC_BASE	KSEG1ADDR(0x1fe80000)

/*
 * Interrupt request levels
 */
#define	KN02_TC_IRQ		2
#define	KN02_RTC_IRQ		3
#define	KN02_MEMCTRLR_IRQ	5

#endif /* __ASM_MIPS_DEC_KN02_H */
